from pytube import YouTube
import time
import sys


def main():

    url = input("Enter the URL of the video to download: ")

    try:
        yt = YouTube(url)

        
        streams = yt.streams

        print("Select the format and quality of the video to download:")
        for i, stream in enumerate(streams):
            print(f"{i + 1}. {stream.resolution} - {stream.type}")

    
        selection = input("Select an option: ")
        stream = streams[int(selection) - 1]

        print("Starting download...")
        for i in range(100):
            time.sleep(0.1)
            sys.stdout.write("\rProgress: %d%%" % i)
            sys.stdout.flush()
        sys.stdout.write("\n")

        stream.download()

        print("Video downloaded successfully:", yt.title)

    except Exception as e:
        print("Error downloading the video:", e)


if __name__ == "__main__":
    main()

